package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.exception.ExtCertPathBuilderException;
import cn.com.infosec.util.Selector;
import cn.com.infosec.x509.ExtendedPKIXBuilderParameters;
import cn.com.infosec.x509.X509AttributeCertStoreSelector;
import cn.com.infosec.x509.X509AttributeCertificate;
import cn.com.infosec.x509.X509CertStoreSelector;
import java.io.IOException;
import java.security.InvalidAlgorithmParameterException;
import java.security.Principal;
import java.security.cert.CertPathBuilderException;
import java.security.cert.CertPathBuilderResult;
import java.security.cert.CertPathBuilderSpi;
import java.security.cert.CertPathParameters;
import java.security.cert.PKIXBuilderParameters;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import javax.security.auth.x500.X500Principal;

public class PKIXAttrCertPathBuilderSpi extends CertPathBuilderSpi {
   private Exception certPathException;

   private CertPathBuilderResult build(X509AttributeCertificate param1, X509Certificate param2, ExtendedPKIXBuilderParameters param3, List param4) {
      // $FF: Couldn't be decompiled
   }

   public CertPathBuilderResult engineBuild(CertPathParameters params) {
      if (!(params instanceof PKIXBuilderParameters) && !(params instanceof ExtendedPKIXBuilderParameters)) {
         throw new InvalidAlgorithmParameterException("Parameters must be an instance of " + PKIXBuilderParameters.class.getName() + " or " + ExtendedPKIXBuilderParameters.class.getName() + ".");
      } else {
         ExtendedPKIXBuilderParameters params1;
         if (params instanceof ExtendedPKIXBuilderParameters) {
            params1 = (ExtendedPKIXBuilderParameters)params;
         } else {
            params1 = (ExtendedPKIXBuilderParameters)ExtendedPKIXBuilderParameters.getInstance((PKIXBuilderParameters)params);
         }

         ArrayList var2;
         var2 = new ArrayList.<init>();
         Selector var3;
         if (!((var3 = params1.getTargetConstraints()) instanceof X509AttributeCertStoreSelector)) {
            throw new CertPathBuilderException("TargetConstraints must be an instance of " + X509AttributeCertStoreSelector.class.getName() + " for " + this.getClass().getName() + " class.");
         } else {
            Collection var10000;
            try {
               var10000 = CertPathValidatorUtilities.findCertificates((X509AttributeCertStoreSelector)var3, params1.getStores());
            } catch (AnnotatedException var10) {
               throw new ExtCertPathBuilderException("Error finding target attribute certificate.", var10);
            }

            Collection var22 = var10000;
            if (var10000.isEmpty()) {
               throw new CertPathBuilderException("No attribute certificate found matching targetContraints.");
            } else {
               CertPathBuilderResult var23 = null;
               Iterator var4 = var22.iterator();

               while(var4.hasNext() && var23 == null) {
                  X509AttributeCertificate var5;
                  X509AttributeCertificate var25 = var5 = (X509AttributeCertificate)var4.next();
                  X509CertStoreSelector var6;
                  var6 = new X509CertStoreSelector.<init>();
                  Principal[] var7 = var25.getIssuer().getPrincipals();
                  HashSet var8;
                  var8 = new HashSet.<init>();

                  for(int var9 = 0; var9 < var7.length; ++var9) {
                     AnnotatedException var27;
                     label111: {
                        IOException var26;
                        label124: {
                           boolean var10001;
                           boolean var28;
                           try {
                              var28 = var7[var9] instanceof X500Principal;
                           } catch (AnnotatedException var17) {
                              var27 = var17;
                              var10001 = false;
                              break label111;
                           } catch (IOException var18) {
                              var26 = var18;
                              var10001 = false;
                              break label124;
                           }

                           if (var28) {
                              try {
                                 var6.setSubject(((X500Principal)var7[var9]).getEncoded());
                              } catch (AnnotatedException var15) {
                                 var27 = var15;
                                 var10001 = false;
                                 break label111;
                              } catch (IOException var16) {
                                 var26 = var16;
                                 var10001 = false;
                                 break label124;
                              }
                           }

                           ExtendedPKIXBuilderParameters var10002;
                           X509CertStoreSelector var29;
                           HashSet var30;
                           try {
                              var30 = var8;
                              var29 = var6;
                              var10002 = params1;
                              var8.addAll(CertPathValidatorUtilities.findCertificates(var6, params1.getStores()));
                           } catch (AnnotatedException var13) {
                              var27 = var13;
                              var10001 = false;
                              break label111;
                           } catch (IOException var14) {
                              var26 = var14;
                              var10001 = false;
                              break label124;
                           }

                           try {
                              var30.addAll(CertPathValidatorUtilities.findCertificates(var29, var10002.getCertStores()));
                              continue;
                           } catch (AnnotatedException var11) {
                              var27 = var11;
                              var10001 = false;
                              break label111;
                           } catch (IOException var12) {
                              var26 = var12;
                              var10001 = false;
                           }
                        }

                        IOException var19 = var26;
                        throw new ExtCertPathBuilderException("cannot encode X500Proncipal.", var19);
                     }

                     AnnotatedException var20 = var27;
                     throw new ExtCertPathBuilderException("Public key certificate for attribute certificate cannot be searched.", var20);
                  }

                  if (var8.isEmpty()) {
                     throw new CertPathBuilderException("Public key certificate for attribute certificate cannot be found.");
                  }

                  for(Iterator var24 = var8.iterator(); var24.hasNext() && var23 == null; var23 = this.build(var5, (X509Certificate)var24.next(), params1, var2)) {
                  }
               }

               if (var23 == null && this.certPathException != null) {
                  throw new ExtCertPathBuilderException("Possible certificate chain could not be validated.", this.certPathException);
               } else if (var23 == null && this.certPathException == null) {
                  throw new CertPathBuilderException("Unable to find certificate chain.");
               } else {
                  return var23;
               }
            }
         }
      }
   }
}
